src/QuadrusMotorCompany.Web/Models/Gallery/VehicleIndexModel.cs
namespace QuadrusMotorCompany.Web.Models.Gallery
{
    public class VehicleIndexModel
    {
        public int Id { get; set; }

        public string Make { get; set; }

        public string Model { get; set; }
        
        public decimal Price { get; set; }
    }
}

src/QuadrusMotorCompany.Web/Controllers/BrandController.cs
namespace QuadrusMotorCompany.Web.Controllers
{
    using System.Collections.Generic;
    using System.Web.Mvc;

    using AutoMapper;

    using QuadrusMotorCompany.Core;
    using QuadrusMotorCompany.Query;
    using QuadrusMotorCompany.Web.Models;

    public class BrandController : Controller
    {
        private readonly IMapper _mapper;
        private readonly IQueryBus _queryBus;

        public BrandController(IMapper mapper, IQueryBus queryBus)
        {
            _mapper = mapper;
            _queryBus = queryBus;
        }

        [ChildActionOnly]
        public ActionResult Index()
        {
            var brands = _queryBus.Query(new BrandQuery());
            var models = _mapper.Map<IList<BrandListingViewModel>>(brands);

            return PartialView("_Index", models);
        }
    }
}

src/QuadrusMotorCompany.Web/Controllers/GalleryController.cs
namespace QuadrusMotorCompany.Web.Controllers
{
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;
    using AutoMapper;
    using QuadrusMotorCompany.Web.Models;
    using QuadrusMotorCompany.Web.Models.Gallery;
    using QuadrusMotorCompany.Core;
    using QuadrusMotorCompany.Query;

    public class GalleryController : Controller
    {
        private readonly IMapper _mapper;
        private readonly IQueryBus _queryBus;

        public GalleryController(IMapper mapper, IQueryBus queryBus)
        {
            _mapper = mapper;
            _queryBus = queryBus;
        }

        [Route("~/gallery")]
        public ActionResult Index()
        {
            return View();
        }

        [Route("~/gallery/brands/{brandName}")]
        public ActionResult ByBrand(string brandName)
        {
            var vehicles = _queryBus.Query(new VehicleQuery(brandName));
            var model = _mapper.Map<IList<VehicleIndexModel>>(vehicles);

            ViewBag.SearchText = brandName;

            return View(model);
        }


        [Route("~/gallery/search/")]
        public ActionResult Search(string q)
        {
            var vehicles = _queryBus.Query(new VehicleSearchQuery(q));
            var model = _mapper.Map<IList<VehicleIndexModel>>(vehicles);
            
            ViewBag.SearchText = q;

            return View(model);
        }
    }
}

src/QuadrusMotorCompany.Web/Controllers/VehicleController.cs
namespace QuadrusMotorCompany.Web.Controllers
{
    using System;
    using System.Collections.Generic;
    using System.Configuration;
    using System.Drawing;
    using System.Drawing.Imaging;
    using System.IO;
    using System.Web.Mvc;

    using AutoMapper;

    using QuadrusMotorCompany.Core;
    using QuadrusMotorCompany.Query;
    using QuadrusMotorCompany.Web.Models.Gallery;
    using QuadrusMotorCompany.Web.Models.Vehicle;

    using Img = System.Drawing.Image;

    public class VehicleController : Controller
    {
        private readonly IQueryBus _queryBus;
        private readonly IMapper _mapper;

        public VehicleController(IQueryBus queryBus, IMapper mapper)
        {
            _queryBus = queryBus;
            _mapper = mapper;
        }

        [ChildActionOnly]
        public ActionResult Index()
        {
            var vehicles = _queryBus.Query(new VehicleQuery());
            var models = _mapper.Map<IList<VehicleIndexModel>>(vehicles);

            return PartialView("_Index", models);
        }

        [Route("~/vehicle/{make}/{model}")]
        public ActionResult Details(string make, string model)
        {
            var vehicle = _queryBus.Query(new VehicleDetailsQuery(make.Replace("_", " "), model.Replace("_", " ")));

            var viewModel = _mapper.Map<VehicleDetailsModel>(vehicle);
            return View(viewModel);
        }

        [Route("~/vehicle/{id}/image")]
        public ActionResult Image(int id, int? width, int? height)
        {
            var vehicleImage = _queryBus.Query(new VehicleImageQuery(id));

            var root = Server.MapPath(ConfigurationManager.AppSettings["VehicleImagePathRoot"]);
            var path = Path.Combine(root, vehicleImage);

            var vehcileImage = Img.FromFile(path);
            if (width.HasValue && height.HasValue)
            {
                vehcileImage = ScaleImage(vehcileImage, width.Value, height.Value);
            }
            
            var byteArray = ConvertToByteArray(vehcileImage);

            return File(byteArray, "image/png");
        }

        private static Img ScaleImage(Img image, int maxWidth, int maxHeight)
        {
            var ratioX = (double)maxWidth / image.Width;
            var ratioY = (double)maxHeight / image.Height;
            var ratio = Math.Min(ratioX, ratioY);

            var newWidth = (int)(image.Width * ratio);
            var newHeight = (int)(image.Height * ratio);

            var newImage = new Bitmap(newWidth, newHeight);

            using (var graphics = Graphics.FromImage(newImage))
            {
                graphics.DrawImage(image, 0, 0, newWidth, newHeight);
            }

            return newImage;
        }

        private static byte[] ConvertToByteArray(Img image)
        {
            byte[] bytes;

            using (var stream = new MemoryStream())
            {
                image.Save(stream, ImageFormat.Png);
                bytes = stream.ToArray();
            }

            return bytes;
        }
    }
}

src/QuadrusMotorCompany.Web/Views/Gallery/ByBrand.cshtml
@model IList<QuadrusMotorCompany.Web.Models.Gallery.VehicleIndexModel>

@{
    ViewBag.Title = "QMC - Vehicle Gallery";
}

<h2>
    Explore Our Vehicle Inventory
</h2>
<hr />

<div class="row">
    <div class="col-md-3">
        <div class="row well">
            @using (Html.BeginForm("Search", "Gallery", FormMethod.Get, new { id = "search", @class = "input-group" }))
            {
                <input name="q" type="text" class="form-control ttspan-fill" placeholder="Search...">
                <span class="input-group-btn ttspan-fill">
                    <button class="btn btn-default" type="button" onclick="document.forms[0].submit()">
                        <i class="fa fa-search"></i>
                    </button>
                </span>
            }
        </div>
        <div class="row">
            <h4>Brands</h4>
            @{ Html.RenderAction("Index", "Brand"); }
        </div>
    </div>

    <div class="col-md-8 col-md-offset-1">
        <div class="row filter-header">
            <span class="label label-mute filter-label">
                @ViewBag.SearchText
                <a href="@Url.Action("Index", "Gallery")"><span class="fa fa-times label-action action-remove"></span></a>
            </span>
        </div>
        <div class="view-grid">
            <div class="row">
                @if (Model.Any())
                {
                    foreach (var vehicle in Model)
                    {
                        @Html.Partial("_Vehicle", vehicle)
                    }
                }
                else
                {
                    <div class="col-md-12">
                        <h4>No vehicles match the current filter criteria</h4>
                    </div>
                }
            </div>
        </div>
    </div>
</div>

src/QuadrusMotorCompany.Web/Views/Gallery/Index.cshtml
@{
    ViewBag.Title = "QMC - Vehicle Gallery";
}

<h2>
    Explore Our Vehicle Inventory
</h2>
<hr />

<div class="row">
    <div class="col-md-3">
        <div class="row well">
            @using (Html.BeginForm("Search", "Gallery", FormMethod.Get, new { id="search", @class = "input-group" }))
            {
                <input name="q" type="text" class="form-control ttspan-fill" placeholder="Search...">
                <span class="input-group-btn ttspan-fill">
                    <button class="btn btn-default" type="button" onclick="document.forms[0].submit()">
                        <i class="fa fa-search"></i>
                    </button>
                </span>
            }
        </div>
        <div class="row">
            <h4>Brands</h4>
            @{ Html.RenderAction("Index", "Brand"); }
        </div>
    </div>

    <div class="col-md-8 col-md-offset-1">
        @{ Html.RenderAction("Index", "Vehicle"); }
    </div>
</div>

src/QuadrusMotorCompany.Web/Views/Gallery/Search.cshtml
@model IList<QuadrusMotorCompany.Web.Models.Gallery.VehicleIndexModel>

@{
    ViewBag.Title = "QMC - Vehicle Gallery";
}

<h2>
    Explore Our Vehicle Inventory
</h2>
<hr />

<div class="row">
    <div class="col-md-3">
        <div class="row well">
            @using (Html.BeginForm("Search", "Gallery", FormMethod.Get, new { id = "search", @class = "input-group" }))
            {
                <input name="q" type="text" class="form-control ttspan-fill" placeholder="Search...">
                <span class="input-group-btn ttspan-fill">
                    <button class="btn btn-default" type="button" onclick="document.forms[0].submit()">
                        <i class="fa fa-search"></i>
                    </button>
                </span>
            }
        </div>
        <div class="row">
            <h4>Brands</h4>
            @{ Html.RenderAction("Index", "Brand"); }
        </div>
    </div>

    <div class="col-md-8 col-md-offset-1">
        <div class="row filter-header">
            <span class="label label-mute filter-label">
                @ViewBag.SearchText
                <a href="@Url.Action("Index", "Gallery")"><span class="fa fa-times label-action action-remove"></span></a>
            </span>
        </div>
        <div class="view-grid">
            <div class="row">
                @if (Model.Any())
                {
                    foreach (var vehicle in Model)
                    {
                        @Html.Partial("_Vehicle", vehicle)
                    }
                }
                else
                {
                    <div class="col-md-12">
                        <h4>No vehicles match the current search criteria</h4>
                    </div>
                }

            </div>
        </div>
    </div>
</div>